<template>
	<div class="quality-project-container layout-pd">
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" :inline="true" @submit.native.prevent>
				<el-form-item label="质检项分组" prop="GroupingName">
					<el-select v-model="state.queryParams.GroupingName" placeholder="请选择质检项目分组">
						<el-option v-for="item in qualityItemGrouping" :value="item.dicDataValue" :key="item.dicDataValue" :label="item.dicDataName" />
					</el-select>
				</el-form-item>
				<el-form-item label="质检项名称" prop="Name">
					<el-input v-model="state.queryParams.Name" placeholder="请输入质检项目名称" clearable @keyup.enter="queryList" style="width: 250px" />
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" v-waves class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<div class="mb20">
				<el-button type="primary" @click="onProjectAdd" v-waves v-auth="'quality:project:add'">
					<SvgIcon name="ele-Plus" class="mr5" />新增
				</el-button>
				<el-button type="primary" @click="onProjectDelete" v-waves v-auth="'quality:project:delete'" :disabled="!multipleSelection.length">
					<SvgIcon name="ele-Delete" class="mr5" />删除
				</el-button>
			</div>
			<!-- 表格 -->
			<el-table :data="state.tableData" v-loading="state.loading" row-key="id" ref="multipleTableRef" @selection-change="handleSelectionChange">
				<el-table-column type="selection" width="55" />
				<el-table-column prop="name" label="质检项名称" show-overflow-tooltip></el-table-column>
				<el-table-column prop="describe" label="质检项描述" show-overflow-tooltip width="130"></el-table-column>
				<el-table-column prop="groupingName" label="质检项分组" show-overflow-tooltip></el-table-column>
				<el-table-column prop="type" label="是否智能质检" show-overflow-tooltip>
					<template #default="{ row }">
						{{ row.isIntelligent === 1 ? '是' : '否' }}
					</template>
				</el-table-column>
				<el-table-column prop="grade" label="分值（分）" show-overflow-tooltip></el-table-column>
				<el-table-column label="是否启用" show-overflow-tooltip>
					<template #default="{ row }">
						<el-switch
							v-model="row.isEnable"
							:active-value="1"
							:inactive-value="0"
							inline-prompt
							active-text="启用"
							inactive-text="禁用"
							@change="changeIsEnable(row)"
							v-if="auth('quality:project:edit')"
						/>
						<span v-else>{{ row.isEnable === 1 ? '启用' : '禁用' }}</span>
					</template>
				</el-table-column>
				<el-table-column prop="creatorName" label="创建人" show-overflow-tooltip></el-table-column>
				<el-table-column prop="creationTime" label="创建时间" show-overflow-tooltip width="170">
					<template #default="{ row }">
						<span>{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}</span>
					</template>
				</el-table-column>
				<el-table-column prop="lastModificationName" label="更新人" show-overflow-tooltip></el-table-column>
				<el-table-column prop="lastModificationTime" label="更新时间" show-overflow-tooltip width="170">
					<template #default="{ row }">
						<span>{{ formatDate(row.lastModificationTime, 'YYYY-mm-dd HH:MM:SS') }}</span>
					</template>
				</el-table-column>
				<el-table-column label="操作" width="120" fixed="right" align="center">
					<template #default="{ row }">
						<el-button link type="primary" @click="onProjectEdit(row)" v-auth="'quality:project:edit'" title="编辑质检项目"> 编辑 </el-button>
					</template>
				</el-table-column>
				<template #empty>
					<Empty />
				</template>
			</el-table>
			<!-- 分页 -->
			<pagination
				:total="state.total"
				v-model:page="state.queryParams.PageIndex"
				v-model:limit="state.queryParams.PageSize"
				@pagination="queryList"
			/>
		</el-card>
		<!--  质检项目新增  -->
		<project-add ref="projectAddRef" @updateList="queryList" :qualityItemGrouping="qualityItemGrouping" />
		<!--  质检项目编辑  -->
		<project-edit ref="projectEditRef" @updateList="queryList" :qualityItemGrouping="qualityItemGrouping" />
	</div>
</template>

<script lang="ts" setup name="qualityProject">
import {defineAsyncComponent, onMounted, reactive, ref} from 'vue';
import {ElMessage, ElMessageBox, FormInstance} from 'element-plus';
import {formatDate} from '/@/utils/formatTime';
import {auth} from '/@/utils/authFunction';
import {projectBaseData, projectDelete, projectList, projectUpdate} from '/@/api/quality/project';

// 引入组件
const ProjectAdd = defineAsyncComponent(() => import('/@/views/quality/project/components/Project-add.vue')); // 质检项目新增
const ProjectEdit = defineAsyncComponent(() => import('/@/views/quality/project/components/Project-edit.vue')); // 质检项目编辑

// 定义变量内容
const state = reactive<any>({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 10,
		GroupingName: null,
		Type: null,
		Name: null,
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<RefType>(null); // 表单ref
const qualityItemGrouping = ref<EmptyArrayType>([]); // 质检项目分组
const getBaseData = async () => {
	try {
		const res = await projectBaseData();
		qualityItemGrouping.value = res.result?.qualityItemGrouping ?? [];
	} catch (error) {
		console.log(error);
	}
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	if (!auth('quality:project:query')) ElMessage.error('抱歉，您没有权限获取质检项目列表！');
	else {
		projectList(state.queryParams)
			.then((res) => {
				state.loading = false;
				state.tableData = res.result.items ?? [];
				state.total = res.result.total ?? 0;
			})
			.finally(() => {
				state.loading = false;
			});
	}
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增质检项目
const projectAddRef = ref<RefType>();
const onProjectAdd = () => {
	projectAddRef.value.openDialog();
};
// 编辑质检项目
const projectEditRef = ref<RefType>();
const onProjectEdit = (row: any) => {
	projectEditRef.value.openDialog(row);
};
// 表格多选
const multipleTableRef = ref<RefType>();
const multipleSelection = ref<any>([]);
const handleSelectionChange = (val: any[]) => {
	multipleSelection.value = val;
};
// 删除质检项目
const onProjectDelete = () => {
	const names = multipleSelection.value.map((item: any) => item.name).join('、');
	const ids = multipleSelection.value.map((item: any) => item.id);
	ElMessageBox.confirm(`您确定要删除：【${names}】质检项目，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			projectDelete({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
//  修改是否启用
const changeIsEnable = (row: any) => {
	ElMessageBox.confirm(`您确定要${row.isEnable ? '启用' : '禁用'}：【${row.name}】质检项，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			const request = {
				...row,
				isEnable: row.isEnable,
			};
			projectUpdate(request)
				.then(() => {
					ElMessage.success('操作成功');
					queryList();
				})
				.catch(() => {
					queryList();
				});
		})
		.catch(() => {
			queryList();
		});
};
// 页面加载时
onMounted(() => {
	getBaseData();
	queryList();
});
</script>

<style lang="scss" scoped>
.quality-project-container {
}
</style>
